/*
** ucview.h
** 
** Made by Arne Caspari
** Login   <arne@arne-laptop>
** 
** Started on  Mon Feb  5 07:47:50 2007 Arne Caspari
** Last update Fri Mar 16 18:37:09 2007 Arne Caspari
*/

#ifndef   	UCVIEW_H_
# define   	UCVIEW_H_

#include <unicap.h>
#include <gtk/gtk.h>
#include <gconf/gconf-client.h>
#include <ucil.h>

#define UCVIEW_GCONF_DIR "/apps/ucview"

typedef void (*image_effect_func_t)(unicap_data_buffer_t *buffer, gpointer data );

struct image_effect_data
{
      gchar *name;
      image_effect_func_t func;
      gpointer data;
};

typedef struct image_effect_data image_effect_data_t;

struct new_frame_data
{
      GtkWidget *display;
      GtkWidget *settings_dialog;
      GtkWidget *property_dialog;

      GList *image_effects;
      GMutex *mutex;

      GConfClient *client;

      unicap_handle_t device_handle;
      unicap_format_t format;
      unicap_data_buffer_t still_image_buffer;

      gboolean line_start_point_set;
      gint line_points[4];

      volatile gboolean record;
      volatile gboolean still_image;
      gchar still_image_path[1024];
      
      ucil_video_file_object_t *video_object;
      gchar *last_video_file;
      unicap_handle_t video_file_handle;
};

typedef struct new_frame_data new_frame_data_t;



#endif 	    /* !UCVIEW_H_ */
